// das Adressbuch speichert alle Kontakte und ermglicht, mit ihnen zu arbeiten

import java.util.*;
import java.io.*;

class Adressbuch implements Serializable {

	// unsere Liste mit den Kontakten
	TreeSet<Kontakt> adressbuch = new TreeSet<Kontakt>();

	// Getter
	TreeSet<Kontakt> getAdressbuch () {
		return adressbuch;
	}
	
	// einen neuen Kontakt hinzufuegen
	// wenn der Kontakt bereits enthalten ist, wird die Methode einfach beendet
	void kontaktHinzufuegen (String vname, String nname, String telnr) {
		/*for (Kontakt k : adressbuch) {
			if (k.getVorname().equals(vname) && k.getNachname().equals(nname) && k.getTelefon().equals(telnr)) {
				return;
			}
		}*/
		adressbuch.add(new Kontakt(vname, nname, telnr));
	}

	// einen Kontakt lschen
	void kontaktLoeschen (Kontakt k) {
		adressbuch.remove(k);
	}
	
	// gibt eine ArrayList mit den gefundenen Kontakten wieder
	TreeSet<Kontakt> kontakteSuchen (String suchstring) {
		TreeSet<Kontakt> gefundeneKontakte = new TreeSet<Kontakt>();  // Ergebnisliste
		for (Kontakt k : adressbuch) {
			if (k.suche(suchstring)) {  // Suchstring im Kontakt vorhanden
				gefundeneKontakte.add(k);
			}
		}
		return gefundeneKontakte;
	}
	
	// das Adressbuch inkl. aller Kontakte serialisieren
	void adressbuchSpeichern () {
		try {
			ObjectOutputStream os = new ObjectOutputStream(new FileOutputStream(new File("adressbuch.ser")));
			os.writeObject(adressbuch);
			os.close();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
	
	// das Adressbuch inkl. aller Kontakte deserialisieren
	void adressbuchLaden () {
		try {
			ObjectInputStream is = new ObjectInputStream(new FileInputStream(new File("adressbuch.ser")));
			Object obj = is.readObject();
			adressbuch = (TreeSet<Kontakt>) obj;
			is.close();
		} catch (FileNotFoundException ex) {
			System.out.println("Exception: Datei adressbuch.ser nicht gefunden!\n");
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
}