// speichert einen einzelnen Kontakt

import java.io.*;

public class Kontakt implements Serializable, Comparable<Kontakt> {
	private String vorname, nachname;
	private String telefon;
	
	public Kontakt (String vname, String nname, String telnr) {
		vorname = vname;
		nachname = nname;
		telefon = telnr;
	}
	
	public boolean suche (String s) {
		if (vorname.contains(s) || nachname.contains(s) || telefon.contains(s))
			return true;
		else
			return false;
	}
	
	public void setVorname (String s) {
		vorname = s;
	}
		
	public String getVorname () {
		return vorname;
	}
	
	public void setNachname (String s) {
		nachname = s;
	}
		
	public String getNachname () {
		return nachname;
	}
	
	public void setTelefon (String s) {
		telefon = s;
	}
		
	public String getTelefon () {
		return telefon;
	}
	
	// wir ueberschreiben toString(), damit die Methode ArrayList.toArray() sinnvolle Werte fuer einen Kontakt zurueckgibt
	public String toString() {
		return vorname + " " + nachname + ":" + telefon;
	}
	
	// Kontakte vergleichen fr Sortierung des TreeSets
	public int compareTo (Kontakt k) {
		String daten1 = vorname + nachname + telefon;
		String daten2 = k.getVorname() + k.getNachname() + k.getTelefon();
		return daten1.compareTo(daten2);
	}
	
	// fr Objektgleichheit, um Duplikate im TreeSet zu vermeiden
	public boolean equals (Object einKontakt) {
		Kontakt k = (Kontakt) einKontakt;
		String daten1 = getVorname() + getNachname() + getTelefon();
		String daten2 = k.getVorname() + k.getNachname() + k.getTelefon();
		return daten1.equals(daten2);
	}

	// fr Objektgleichheit
	public int hashCode () {
		String daten1 = getVorname() + getNachname() + getTelefon();
		return daten1.hashCode();
	}
}